SystemOrganization addCategory: #'TADP-Meta1'!

Trait named: #Interceptor
	uses: {}
	category: 'TADP-Meta1'!

!Interceptor methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 13:31'!
codigoInterceptor: unCodigo
	
	(Interceptor compile: unCodigo). ! !

!Interceptor methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 03:54'!
intercepcion
	self antes.
	self interceptionVieja.
	self despues.! !

Trait named: #TraitDeMetodos
	uses: {}
	category: 'TADP-Meta1'!

!TraitDeMetodos methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 03:54'!
intercepcion ! !

Object subclass: #Alguna
	uses: Interceptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

Alguna class
	uses: Interceptor classTrait
	instanceVariableNames: ''!

Object subclass: #Manager
	uses: Interceptor @ {#intercepcionVieja->#intercepcion} + TraitDeMetodos
	instanceVariableNames: 'categoryClasses estrategia algebraDeTraits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

Manager class
	uses: Interceptor classTrait + TraitDeMetodos classTrait
	instanceVariableNames: ''!

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/2/2013 19:32'!
categoryClasses
	^categoryClasses.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/2/2013 19:32'!
categoryClasses: unasClases 
	categoryClasses:=unasClases .! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 13:00'!
configurarClases

	self 
		categoryClasses
				 do: [: unaClase | self pasarMetodosDe: unaClase a: TraitDeMetodos.
					unaClase addToComposition: TraitDeMetodos. 
						unaClase addToComposition: Interceptor @{#intercepcionVieja -> #intercepcion}.
							]! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/2/2013 19:33'!
estrategia
	^estrategia.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/2/2013 19:33'!
estrategia: unBloque 
	estrategia:= unBloque.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 03:52'!
initialize 
	self categoryClasses: Set new.
	self estrategia: [:selector | (selector beginsWith: 'a') | (selector beginsWith: 'c')].! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 12:49'!
metodosAinterceptarDe: unaClase

	^ (unaClase selectors) select: self estrategia.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 12:51'!
obtenerCategoryClassesDe: unaCategoria

	self categoryClasses: ((SystemOrganization listAtCategoryNamed: unaCategoria) 
							collect: [:each | Smalltalk globals at: each]).

	^ self categoryClasses.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 13:08'!
pasarMetodosDe: unaClase a: unTrait
 		
	(self metodosAinterceptarDe: unaClase)
		do: [:selector | unTrait compile: (unaClase >> selector) sourceCode.
				unaClase removeSelector: selector.].! !
